module.exports = function (grunt) {
    // Project configuration.
    grunt.initConfig({
        pkg: grunt.file.readJSON('package.json'),
        // Task configuration
        bower_concat: {
            all: {
                dest: 'js/dist/bundle.js',
                mainFiles: {
                    'angular': ['angular.js'],
                    'jquery': ['dist/jquery.js'],
                    'dmak': ['dist/dmak.js', 'dist/jquery.dmak.js']
                },
                dependencies: {
                    'angular': 'jquery'
                },
                includeDev: true,
                bowerOptions: {
                    relative: true
                }
            }
        },
        uglify: {
            bower: {
                files: {
                    'js/bundle.min.js': ['js/dist/bundle.js']
                }
            },
            config: {
                files: {
                    'js/config.min.js': ['js/dist/config.js']
                }
            },
            services: {
                files: {
                    'js/release.min.js': ['js/dist/services.js','js/dist/directives.js','js/dist/controller.js']
                }
            }
        },
        ngAnnotate: {
            options: {
                singleQuotes: true
            },
            dist: {
                files: [
                    {
                        expand: true,
                        src: [
                            'js/controllers/*.js',
                            'js/directives/*.js',
                            'js/services/*.js'
                        ],
                        dest: 'js/dist/annotated/'
                    }
                ]
            }
        },
        concat: {
            config: {
                files: {
                    'js/dist/config.js': ['js/config/config.js','index.js']
                }
            },
            services: {
                files: {
                    'js/dist/services.js': [
                        'js/dist/annotated/js/services/MainService.js'
                    ]
                }
            },
            directives: {
                files: {
                    'js/dist/directives.js': [
                        'js/dist/annotated/js/directives/MainDirective.js'
                    ]
                }
            },
            controller: {
                files: {
                    'js/dist/controller.js': [
                        'js/dist/annotated/js/controllers/MainController.js'
                    ]
                }
            }
        }
    });
    grunt.loadNpmTasks('grunt-jssemicoloned');
    grunt.loadNpmTasks('grunt-contrib-jshint');
    grunt.loadNpmTasks('grunt-bower-concat');
    grunt.loadNpmTasks('grunt-ng-annotate');
    grunt.loadNpmTasks('grunt-contrib-concat');
    grunt.loadNpmTasks('grunt-contrib-uglify');

    grunt.registerTask('default', ['ngAnnotate','bower_concat','concat','uglify']);
};