/**
 * Created by akira on 3/30/17.
 */
'use strict';
var app = angular.module('main', [
    'app.controller','app.service','app.directive','ngAudio','ds.clock','pascalprecht.translate','ngCookies'
]);
app.config(function ($compileProvider, $httpProvider , $translateProvider) {
    $compileProvider.imgSrcSanitizationWhitelist(/^\s*((https?|ftp|file|blob|chrome-extension):|data:image\/)/);
    $httpProvider.defaults.useXDomain = true;
    $httpProvider.defaults.headers.post["Access-Control-Allow-Origin"] = "*";
    $httpProvider.defaults.headers.post["Access-Control-Allow-Headers"] ="Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With,Access-Control-Allow-Origin";
    $httpProvider.useApplyAsync(true);
    $translateProvider.useCookieStorage();
    var language;

    if ((localStorage.language === null && localStorage.language === undefined ) && localStorage.language === 'en' ) {
        language = 'en';
    } else {
        language = 'en';
    }

    $translateProvider.useStaticFilesLoader({
        prefix: 'translate/translate-',
        suffix: '.json'
    }).registerAvailableLanguageKeys([
        language
    ], {
        'en_US': 'en',
        'en_UK': 'en',
        'en_GB': 'en'
    }).preferredLanguage(language).fallbackLanguage(language);
});

app.run(function () {
});
