/**
 *
 * @type {string}
 */
"use strict";

var config_app = "Akira";
var config_url = {
    "url_redirect" : 'https://akirademy.com/?utm_source=extension&utm_medium=button',
    "url_logo" : 'http://akirademy.com/?utm_source=extension&utm_medium=logo&utm_campaign=AkiraUS',
    "link_support" : "https://docs.google.com/forms/d/e/1FAIpQLSd5IZ6d2z9rzbKPQjXeqPfX1p6qFU5WJNpIvMUvWhubnsvnNA/viewform",
    "link_feedback" : "https://docs.google.com/forms/d/e/1FAIpQLScK6T8kEov2U8OgOTzgltGHshPrMgclCkttgCbDeTzuddtH1Q/viewform"
};
var total = {
    stage : 2,
    word : 96,
    kanji : 49,
    hiragana : 46,
    katakana : 46,
    phrase : 30
};
var isArr = {
    word : [1],
    kanji : [2],
    hiragana : [3],
    katakana : [4],
    phrase : [5]

};
(function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = 'https://ssl.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
})();
var _gaq = _gaq || [];
_gaq.push(['_setAccount', 'UA-47075723-31']);//Akirademy
_gaq.push(['_trackPageview']);
_gaq.push(['_trackEvent', 'Akira Global Extension', 'Akira Extension']);

var utils = {
    resetClickHandler : function(element, handler){
        element.off('click');
        element.on('click', handler);
    },
    resetMouseEnterHandler : function(element, handler){
        element.off('mouseenter');
        element.on('mouseenter', handler);
    },
    customizePerDay : function(name,condition,callback) {
        var _start = localStorage.getItem(name);
        if (_start == undefined && _start ==  null) {
            var time = new Date();
            var hours = time.getHours();
            time = (time.getMonth() + 1)  + '/' + (time.getDate() - 1) + '/' + time.getFullYear();
            localStorage.setItem(name, time);
            if (_.contains(condition, hours)) {
                callback(true)
            }
        } else {
            var current_date = new Date();
            var used_date = new Date(_start);
            var rest = current_date.getTime() - used_date.getTime();
            var days = Math.floor(rest / 1000 / 60 / 60 / 24);
            if ( days > 0 && _.contains(condition, current_date.getHours())) {
                var a = new Date();
                a = (a.getMonth() + 1)  + '/' + a.getDate() + '/' + a.getFullYear();
                localStorage.setItem(name, a);
                callback(true)
            } else {
                callback(false)
            }
        }
    }
};
window.utils = utils;