/**
 * Created by akira on 3/30/17.
 */
"use strict";
angular.module('app.controller',[])
    .controller('mainController', mainController);
mainController.$inject = ['$scope','mainService','ngAudio','$rootScope','$translate'];
function mainController($scope,$service,ngAudio,$rootScope,$translate) {

    var sample_number, sample_kanji , sample_hiragana, sample_katakana, sample_phrase;
    setInit();
    calculate();

    var enable = JSON.parse(localStorage.getItem('enable'));
    if (enable ===  null ||  enable === undefined ) {
        localStorage.setItem('enable',JSON.stringify({word : 1,kanji : 1, hiragana : 0, katakana : 0, phrase : 0 }));
        enable = JSON.parse(localStorage.getItem('enable'));
    }
    var track_with_percent = [];
    _.map(enable,function(val,key){
        if (val === 1 && key === "word") {
            track_with_percent.push(1);
        } else if (val === 1 && key === "kanji") {
            track_with_percent.push(2);
        } else if (val === 1 && key === "hiragana") {
            track_with_percent.push(3);
        } else if (val === 1 && key === "katakana") {
            track_with_percent.push(4);
        } else if (val === 1 && key === "phrase") {
            track_with_percent.push(5);
        }
    });
    var ck , isChoose,
        _twp, isTwp ,
        _kanji, _isKanji,
        _hiragana, _isHiragana,
        _katakana, _isKatakana,
        _phrase, _isPhrase;


    function calculate() {
        var _start = localStorage.getItem('_start');
        var _wpd = JSON.parse(localStorage.getItem('_wpd'));
        var _ne = JSON.parse(localStorage.getItem('_ne'));
        var _ns = JSON.parse(localStorage.getItem('_ns'));
        var _nekj = JSON.parse(localStorage.getItem('_nekj'));
        var _nskj = JSON.parse(localStorage.getItem('_nskj'));
        var _nehk = JSON.parse(localStorage.getItem('_nehk'));
        var _nshk = JSON.parse(localStorage.getItem('_nshk'));
        var _neph = JSON.parse(localStorage.getItem('_neph'));
        var _nsph = JSON.parse(localStorage.getItem('_nsph'));


        if (_start != null && _start != undefined) {
            var current_date = new Date();
            var used_date = new Date(_start);
            var rest = current_date.getTime() - used_date.getTime();
            var days = Math.floor(rest / 1000 / 60 / 60 / 24);
            if ( days > 0 ) {
                var ne = (_ne + _wpd) > total.word  ? ((_ns + _wpd) > total.word ? _wpd : total.word) :  (_ne + _wpd);
                var ns = (_ns + _wpd) > total.word ? 0 : (_ns + _wpd);

                localStorage.setItem('_ns',ns);
                localStorage.setItem('_ne',ne) ;

                var nekj = (_nekj + _wpd) > total.kanji  ? ((_nskj + _wpd) > total.kanji ? _wpd : total.kanji) :  (_nekj + _wpd);
                var nskj = (_nskj + _wpd) > total.kanji ? 0 : (_nskj + _wpd);

                localStorage.setItem('_nskj',nskj);
                localStorage.setItem('_nekj',nekj) ;

                var nehk = (_nehk + _wpd) > total.katakana  ? ((_nshk + _wpd) > total.katakana ? _wpd : total.katakana) :  (_nehk + _wpd);
                var nshk = (_nshk + _wpd) > total.katakana ? 0 : (_nshk + _wpd);

                localStorage.setItem('_nshk',nshk);
                localStorage.setItem('_nehk',nehk) ;

                var neph = (_neph + _wpd) > total.phrase  ? ((_nsph + _wpd) > total.phrase ? _wpd : total.phrase) :  (_neph + _wpd);
                var nsph = (_nsph + _wpd) > total.phrase ? 0 : (_nsph + _wpd);

                localStorage.setItem('_nsph',nsph);
                localStorage.setItem('_neph',neph) ;

                var a = new Date();
                a = (a.getMonth() + 1)  + '/' + a.getDate() + '/' + a.getFullYear();
                localStorage.setItem('_start', a);
                sample_number = _.range(ns,ne);
                sample_kanji = _.range(nskj,nekj);
                sample_hiragana = _.range(nshk,nehk);
                sample_katakana = _.range(nshk,nehk);
                sample_phrase = _.range(nsph,neph);
            } else {
                if ( _wpd != 5 && _wpd != 10 && _wpd != 3) {
                    sample_number = _.range(total.word);
                    sample_kanji = _.range(total.kanji);
                    sample_hiragana = _.range(total.hiragana);
                    sample_katakana = _.range(total.katakana);
                    sample_phrase = _.range(total.phrase);
                } else {

                    _ne = _ne > total.word ? _ns > total.word ? _wpd : total.word :  _ne;
                    _ns = _ns > total.word ? 0 : _ns;

                    localStorage.setItem('_ns',_ns);
                    localStorage.setItem('_ne',_ne) ;

                    _nekj = _nekj > total.kanji ? _nskj > total.kanji ? _wpd : total.kanji :  _nekj;
                    _nskj = _nskj > total.kanji ? 0 : _nskj;

                    localStorage.setItem('_nskj',_nskj);
                    localStorage.setItem('_nekj',_nekj) ;

                    _nehk = _nehk > total.hiragana ? _nshk > total.hiragana ? _wpd : total.hiragana :  _nehk;
                    _nshk = _nshk > total.hiragana ? 0 : _nshk;

                    localStorage.setItem('_nshk',_nshk);
                    localStorage.setItem('_nehk',_nehk) ;

                    _neph = _neph > total.phrase ? _nsph > total.phrase ? _wpd : total.phrase :  _neph;
                    _nsph = _nsph > total.phrase ? 0 : _nsph;

                    localStorage.setItem('_nsph',_nsph);
                    localStorage.setItem('_neph',_neph) ;

                    sample_number = _.range(_ns,_ne);
                    sample_kanji = _.range(_nskj,_nekj);
                    sample_hiragana = _.range(_nshk,_nehk);
                    sample_katakana = _.range(_nshk,_nehk);
                    sample_phrase = _.range(_nsph,_neph);
                }
            }
        } else {
            sample_number = _.range(total.word);
            sample_kanji = _.range(total.kanji);
            sample_hiragana = _.range(total.hiragana);
            sample_katakana = _.range(total.katakana);
            sample_phrase = _.range(total.phrase);
        }
    }

    function setInit() {
        var _nekj = JSON.parse(localStorage.getItem('_nekj'));
        var _nskj = JSON.parse(localStorage.getItem('_nskj'));
        var _nehk = JSON.parse(localStorage.getItem('_nehk'));
        var _nshk = JSON.parse(localStorage.getItem('_nshk'));
        var _neph = JSON.parse(localStorage.getItem('_neph'));
        var _nsph = JSON.parse(localStorage.getItem('_nsph'));
        var _wpd = JSON.parse(localStorage.getItem('_wpd'));
        if ( _nekj === undefined || _nskj === null ) {
            localStorage._nskj = 0;
            localStorage._nekj = _wpd;
        }

        if (_nehk === undefined || _nshk === null ) {
            localStorage._nshk = 0;
            localStorage._nehk = _wpd;
        }

        if (_neph === undefined || _nsph === null) {
            localStorage._nsph = 0;
            localStorage._neph = _wpd;
        }
    }

    $scope.nextWord = function () {
        calculate();
        is_learn_word();
    };
    $scope.nextPhrase = function (type) {
        calculate();
        is_phrase();
        _gaq.push(['_trackEvent', config_app + ' Click', 'Phrase',type]);
    };
    $scope.nextKanji = function (id, type) {
        calculate();
        if (type == 'is_kanji') {
            resetDraw(id);
            is_kanji();
        } else if (type == 'is_hiragana') {
            resetDraw(id);
            is_hiragana();
        } else {
            resetDraw(id);
            is_katakana();
        }
    };
    $scope.advertisement = ads[_.sample(_.range(11))];
    function resetDraw(id) {
        var drawhtml = $(id);
        drawhtml.html(""),
        drawhtml.data("plugin_dmak") && (drawhtml.dmak("reset"),
            drawhtml.data("plugin_dmak", null));
    }
    $scope.enable = enable;
    random_percent();
    function is_learn_word () {
        var isDisplay  = localStorage.getItem('_ck');
        if (isDisplay != undefined || isDisplay != null) {
            ck = _.difference(sample_number, JSON.parse(isDisplay));
            isChoose = _.sample(ck);
            var local = JSON.parse(localStorage.getItem('_ck'));
            local.push(isChoose);
            localStorage.setItem('_ck',JSON.stringify(local));
            if (ck.length <= 1) {
                localStorage.removeItem('_ck');
            }
        } else {
            ck = sample_number;
            isChoose = _.sample(ck);
            var new_local = [];
            new_local.push(isChoose);
            localStorage.setItem('_ck',JSON.stringify(new_local));
        }
        $scope.word_day = word_day[isChoose];
        $scope.image = chrome.extension.getURL("images/word/"+ $scope.word_day.image);
        $scope.sound = ngAudio.load("audios/word/"+$scope.word_day.audio);
    }
    function is_kanji () {
        var isDisplay  = localStorage.getItem('_kanji');
        if (isDisplay != undefined || isDisplay != null) {
            _kanji = _.difference(sample_kanji, JSON.parse(isDisplay));
            _isKanji = _.sample(_kanji);
            var local = JSON.parse(localStorage.getItem('_kanji'));
            local.push(_isKanji);
            localStorage.setItem('_kanji',JSON.stringify(local));
            if (_kanji.length <= 1) {
                localStorage.removeItem('_kanji');
            }
        } else {
            _kanji = sample_kanji;
            _isKanji = _.sample(_kanji);
            var new_local = [];
            new_local.push(_isKanji);
            localStorage.setItem('_kanji',JSON.stringify(new_local));
        }
        $scope.kanji = kanji[_isKanji];
        $("#draw").dmak($scope.kanji.kanji,{
            "uri":'assets/svg/',
            'step' : 0.02,
            "grid" :{
                "show" : true
            },
            "height" : 200,
            "width" : 200
        });
    }
    function is_hiragana () {
        var isDisplay  = localStorage.getItem('_hiragana');
        if (isDisplay != undefined || isDisplay != null) {
            _hiragana = _.difference(sample_hiragana, JSON.parse(isDisplay));
            _isHiragana = _.sample(_hiragana);
            var local = JSON.parse(localStorage.getItem('_hiragana'));
            local.push(_isHiragana);
            localStorage.setItem('_hiragana',JSON.stringify(local));
            if (_hiragana.length <= 1) {
                localStorage.removeItem('_hiragana');
            }
        } else {
            _hiragana = sample_hiragana;
            _isHiragana = _.sample(_hiragana);
            var new_local = [];
            new_local.push(_isHiragana);
            localStorage.setItem('_hiragana',JSON.stringify(new_local));
        }
        $scope.hiragana = hiragana_katakana[_isHiragana];
        $("#draw-hira").dmak($scope.hiragana.hira,{
            "uri":'assets/svg/',
            'step' : 0.02,
            "grid" :{
                "show" : true
            },
            "height" : 200,
            "width" : 200
        });
        $scope.sound_hira = ngAudio.load("audios/hira/"+$scope.hiragana.audio);
    }
    function is_katakana () {
        var isDisplay  = localStorage.getItem('_katakana');
        if (isDisplay != undefined || isDisplay != null) {
            _katakana = _.difference(sample_katakana, JSON.parse(isDisplay));
            _isKatakana = _.sample(_katakana);
            var local = JSON.parse(localStorage.getItem('_katakana'));
            local.push(_isKatakana);
            localStorage.setItem('_katakana',JSON.stringify(local));
            if (_katakana.length <= 1) {
                localStorage.removeItem('_katakana');
            }
        } else {
            _katakana = sample_katakana;
            _isKatakana = _.sample(_katakana);
            var new_local = [];
            new_local.push(_isKatakana);
            localStorage.setItem('_katakana',JSON.stringify(new_local));
        }
        $scope.katakana = hiragana_katakana[_isKatakana];
        $("#draw-kata").dmak($scope.katakana.kata,{
            "uri":'assets/svg/',
            'step' : 0.02,
            "grid" :{
                "show" : true
            },
            "height" : 200,
            "width" : 200
        });
        $scope.sound_kata = ngAudio.load("audios/hira/"+$scope.katakana.audio);
    }
    function is_phrase () {
        var isDisplay  = localStorage.getItem('_phrase');
        if (isDisplay != undefined || isDisplay != null) {
            _phrase = _.difference(sample_phrase, JSON.parse(isDisplay));
            _isPhrase = _.sample(_phrase);
            var local = JSON.parse(localStorage.getItem('_phrase'));
            local.push(_isPhrase);
            localStorage.setItem('_phrase',JSON.stringify(local));
            if (_phrase.length <= 1) {
                localStorage.removeItem('_phrase');
            }
        } else {
            _phrase = sample_phrase;
            _isPhrase = _.sample(_phrase);
            var new_local = [];
            new_local.push(_isPhrase);
            localStorage.setItem('_phrase',JSON.stringify(new_local));
        }
        $scope.phrase = phrase[_isPhrase];
        $scope.sound_phrase = ngAudio.load($scope.phrase.audio);
    }
    function random_percent () {
        var isDisplay  = localStorage.getItem('_twp');
        if (isDisplay != undefined || isDisplay != null) {
            _twp = _.difference(track_with_percent, JSON.parse(isDisplay));
            isTwp = _.sample(_twp);
            if (isTwp === undefined) {
                _twp = track_with_percent;
                isTwp = _.sample(_twp);
                var new_locals = [];
                new_locals.push(isTwp);
                localStorage.setItem('_twp',JSON.stringify(new_locals));
            } else {
                var local = JSON.parse(localStorage.getItem('_twp'));
                local.push(isTwp);
                localStorage.setItem('_twp',JSON.stringify(local));
                if (_twp.length <= 1) {
                    localStorage.removeItem('_twp');
                }
            }

        } else {
            _twp = track_with_percent;
            isTwp = _.sample(_twp);
            var new_local = [];
            new_local.push(isTwp);
            localStorage.setItem('_twp',JSON.stringify(new_local));
        }
        accept_show(isTwp)
    }
    function accept_show (i) {
        if(_.contains(isArr.word, i)) {
            is_learn_word();
            $scope.isLearn_word = true;
            $scope.isKanji = false;
            $scope.isHiragana = false;
            $scope.isKatakana = false;
            $scope.isPhrase = false;
        } else if (_.contains(isArr.kanji, i)) {
            is_kanji();
            $scope.isLearn_word = false;
            $scope.isKanji = true;
            $scope.isHiragana = false;
            $scope.isKatakana = false;
            $scope.isPhrase = false;
        } else if (_.contains(isArr.hiragana, i)) {
            is_hiragana();
            $scope.isLearn_word = false;
            $scope.isKanji = false;
            $scope.isHiragana = true;
            $scope.isKatakana = false;
            $scope.isPhrase = false;
        } else if (_.contains(isArr.katakana, i)) {
            is_katakana();
            $scope.isLearn_word = false;
            $scope.isKanji = false;
            $scope.isHiragana = false;
            $scope.isKatakana = true;
            $scope.isPhrase = false;
        } else if (_.contains(isArr.phrase, i)) {
            is_phrase();
            $scope.isLearn_word = false;
            $scope.isKanji = false;
            $scope.isHiragana = false;
            $scope.isKatakana = false;
            $scope.isPhrase = true;
        } else {
            $scope.isLearn_word = false;
            $scope.isKanji = false;
            $scope.isHiragana = false;
            $scope.isKatakana = false;
            $scope.isPhrase = false;
        }
        interval();
    }

    chrome.runtime.onUpdateAvailable.addListener(function(details) {
        chrome.runtime.reload();
    });

    chrome.runtime.requestUpdateCheck(function(status) {
        if (status === "update_available") {
            $scope.is_update = true;
            localStorage._wupdate = false;
        } else if (status === "no_update") {
            $scope.is_update = false;
            localStorage._wupdate = false ;
        } else if (status === "throttled") {
            $scope.is_update = false;
            localStorage._wupdate = false;
        }
    });

    var rating = localStorage.getItem('rating');
    var rated = localStorage.getItem('rated');
    var _wait = localStorage.getItem('_wait');
    $scope.isShowRating = true;

    if (rating != undefined || rating != null) {
        var number = ++rating;
        if (number > 5 && rated === 'false') {
            $scope.isShowRating = true;
            ratingFunction();
        } else if (number > 5 && rated === 'true' ) {
            if (_wait === 'true') {
                $scope.isShowRating = true;
            } else {
                $scope.isShowRating = false;
            }
        }
        localStorage.setItem('rating',number);
    } else {
        localStorage.setItem('rating',1);
        localStorage.setItem('rated',false);
    }
    $scope.url_tracking = config_url.url_redirect;
    $scope.logo = config_url.url_logo;
    function ratingFunction() {
        swal({
            title: "We want to create the best experience for you. Do you love us?",
            imageUrl: "images/heart.png",
            showCancelButton: true,
            cancelButtonText: "No",
            confirmButtonColor: "#DD6B55",
            confirmButtonText: "Yes",
            closeOnConfirm: false
        }, function(isConfirm){
            if (isConfirm) {
                _gaq.push(['_trackEvent', config_app + ' Click', 'Rất thích','Rất thích']);
                swal({
                    title: "Give us 5 stars",
                    imageUrl: "images/star.png",
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: "Rate now",
                    allowOutsideClick : true,
                    closeOnConfirm: true
                }, function(confirm){
                    if (confirm) {
                        $scope.isShowRating = false;
                        _gaq.push(['_trackEvent', config_app + ' Click', 'Tặng ngay','Tặng ngay']);
                        localStorage.setItem('rated',true);
                        localStorage.setItem('_wait',false);
                        chrome.tabs.create({url: "https://chrome.google.com/webstore/detail/"+chrome.runtime.id+"/reviews" });
                    }
                });

            } else {
                _gaq.push(['_trackEvent', config_app + ' Click', 'Không thích','Không thích']);
                $scope.isShowRating = true;
                localStorage.setItem('rated',true);
                localStorage.setItem('_wait',true);
                chrome.tabs.create({url: config_url.link_support });

            }
        });
    }

    if (localStorage.getItem('level') === undefined || localStorage.getItem('level') ===  null ) {
        swal({
            title: "",
            text: '<h3 class="content_user text-left">Choose content you want to learn:</h3>'+
            '<ul class="list">'+
            '<li class="socap_content"><a>Basic</a></li>'+
            '<li class="trungcap_content"><a >Communication</a></li>'+
            '<li class="caocap_content"><a >JLPT</a></li>' +
            '</ul>' +
            '<h3 class="current text-left">Your level: </h3>'+
            '<ul class="list">'+
            '<li class="socap"><a >Basic</a></li>'+
            '<li class="trungcap"><a >Intermediate</a></li>'+
            '<li class="caocap"><a >Advance</a></li>'+
            '</ul>'+
            '<h3 class="content_user text-left">Choose type of content you want to learn: </h3>'+
            '<ul class="list word_learn">'+
            '<li class="hiragana_display '+(enable.hiragana === 1 ? "active" : "") +'"><div class="click-three check " ></div><a >Hiragana</a></li>'+
            '<li class="katakana_display'+(enable.katakana === 1 ? "active" : "") +'"><div class="click-three check " ></div><a >Katakana</a></li>'+
            '<li class="word_display '+(enable.word === 1 ? "active" : "") +'"><div class="click-three check" ></div><a>Vocabulary</a></li>'+
            '<li class="kanji_display '+(enable.kanji === 1 ? "active" : "") +'"><div class="click-three check " ></div><a >Kanji</a></li>'+
            '<li class="phrase_display display_none '+(enable.phrase === 1 ? "active" : "") +'"><div class="click-three check " ></div><a >Phrase</a></li>'+
            '</ul>',
            html: true,
            confirmButtonColor: "#222B63",
            confirmButtonText: "Learn now",
            customClass : "button-font"
        }, function(isConfirm){
            _gaq.push(['_trackEvent', config_app + ' Click', 'Luyện tập cùng Akira','Learn now']);
            localStorage.level = true;
        });
    }

    function updateEnable() {
        localStorage.setItem('enable',JSON.stringify(enable));
        $scope.enable = enable;
    }

    chrome.topSites.get(function(data) {
        var topSites  = _.filter(data, function(number,key) {
            return key < 10
        });
        var visited = $("#topsites_menu");
        for (var i = 0 ; i < 10 ; i ++) {
            var link_icon = "https://www.google.com/s2/favicons?domain="+topSites[i].url;
            var hr = i === 9 ? '' : '<hr>';
            visited.append('<div>' +
                '<a href="'+topSites[i].url+'"> ' +
                    '<i style="background-image:url('+link_icon+');background-size:cover;"></i>' +topSites[i].title +
                '</a>' +
                '</div>'+ hr)
        }
	});
    var current_date = new Date();
    var day = ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];
    $scope.day = day[current_date.getDay()];
    $scope.full_day = current_date.getDate()+ '.' + (current_date.getMonth() + 1) + '.' + current_date.getFullYear();
    var selectedRow = -1;
    var resultsLength = 0;
    var textBox = $('input#search-input');
    $scope.listSearch = [];
    $("#search-input").keyup(function (event) {
        var key_word = $(this).val();

        $service.search(key_word, function (response) {
            if ( response.status === 200 ) {
                $('#search-suggestion-pad').attr("style", "display: block !important");
                $scope.listSearch  = _.filter(response.data[1], function(number,key) {
                    return key < 5
                });

                resultsLength  = $scope.listSearch.length;
            } else {
                $scope.listSearch = [];
                $('#search-suggestion-pad').attr("style", "display: none !important");
            }
        });
        if (event.keyCode === 13) {
            $scope.redirect(key_word)
        }
    });
    $("#search-input").keydown(function (event) {
        var keyCode = event.keyCode;
        if((keyCode!=38) && (keyCode!=40)){
        } else {
            if(keyCode===38){
                if(selectedRow!=-1){
                    document.getElementById("auto-suggest-row" + selectedRow).setAttribute("class", "");
                }
                selectedRow--;
                if(selectedRow<0){
                    selectedRow = resultsLength-1;
                }
            }else{
                if(selectedRow!=-1){
                    document.getElementById("auto-suggest-row" + selectedRow).setAttribute("class", "");
                }
                selectedRow++;
                if (selectedRow>=resultsLength){
                    selectedRow = 0;
                }
            }
            var row = document.getElementById("auto-suggest-row" + selectedRow);
            row.setAttribute("class", "selected");
            textBox.value = row.textContent;
        }
    });
    $scope.redirect = function (key) {
        _gaq.push(['_trackEvent', config_app + ' Click', 'search','search']);
        window.location.href = "https://www.google.com/search?sourceid=chrome&ie=utf-8&oe=utf-8&aq=t&hl=en-US&q="+key;
    };
    $('body').click(function () {
        $('#search-suggestion-pad').attr("style", "display: none !important");
    });
    $scope.redirect_link = function (key) {
        window.location.href = key
    };
    $('nav').off('mouseleave');
    $('nav').on('mouseleave', hideMenu);
    utils.resetClickHandler($('#lnk_topsites'), function (e) {
        e.stopPropagation();
            _gaq.push(['_trackEvent', config_app + ' Click', 'top_sites','top_sites']);
        $('#topsites_menu').toggle(200);
        $('#share_menu').fadeOut(200);
        $('#support_menu').fadeOut(200);
        $('#setting_menu').fadeOut(200);
    });
    utils.resetClickHandler($('#click-Rate'), function (e) {
        _gaq.push(['_trackEvent', config_app + ' Click', 'rate','rate']);
        e.stopPropagation();
        ratingFunction();

    });
    utils.resetClickHandler($('#lnk_share'), function (e) {
        e.stopPropagation();
        $('#topsites_menu').fadeOut(200);
        $('#share_menu').toggle(200);
        $('#support_menu').fadeOut(200);
        $('#setting_menu').fadeOut(200);
    });
    utils.resetClickHandler($('#click-ShareFB'), function(){
        hideMenu();
        _gaq.push(['_trackEvent', config_app + ' Click', 'Top Menu - Share','share Facebook']);
        chrome.tabs.create({url: "https://www.facebook.com/sharer/sharer.php?u=https://chrome.google.com/webstore/detail/"+chrome.runtime.id });
    });
    $scope.idchrome = chrome.runtime.id;
    utils.resetClickHandler($('#click-ShareGG'), function(){
        hideMenu();
        _gaq.push(['_trackEvent', config_app + ' Click', 'Top Menu - Share ','share Google']);
        chrome.tabs.create({url: "https://plus.google.com/share?url=https://chrome.google.com/webstore/detail/"+chrome.runtime.id });
    });
    utils.resetClickHandler($('#lnk_support'), function (e) {
        e.stopPropagation();
        hideMenu();
        _gaq.push(['_trackEvent', config_app + ' Click', 'support','support']);
        chrome.tabs.create({url: config_url.link_support });
    });
    utils.resetClickHandler($('#lnk_feedback'), function (e){
        e.stopPropagation();
        hideMenu();
        _gaq.push(['_trackEvent', config_app + ' Click', 'Góp ý','Góp ý']);
        chrome.tabs.create({url: config_url.link_feedback });
    });
    utils.resetClickHandler($('.socap'), function (e) {
        e.stopPropagation();
        if (!$(this).hasClass("active")) {
            $(this).toggleClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Trình độ hiện tại','Sơ cấp']);
        }
        $('.trungcap').removeClass("active");
        $('.caocap').removeClass("active");
    });
    utils.resetClickHandler($('.trungcap'), function (e) {
        e.stopPropagation();
        if (!$(this).hasClass("active")) {
            $(this).toggleClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Trình độ hiện tại','Trung cấp']);
        }
        $('.socap').removeClass("active");
        $('.caocap').removeClass("active");
    });
    utils.resetClickHandler($('.caocap'), function (e) {
        e.stopPropagation();
        if (!$(this).hasClass("active")) {
            $(this).toggleClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Trình độ hiện tại','Cap cấp']);
        }
        $('.socap').removeClass("active");
        $('.trungcap').removeClass("active");
    });
    utils.resetClickHandler($('.socap_content'), function (e) {
        e.stopPropagation();
        if (!$(this).hasClass("active")) {
            $(this).toggleClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Nội dung bạn muốn học','Sơ cấp']);
        }
        $('.trungcap_content').removeClass("active");
        $('.caocap_content').removeClass("active");
    });
    utils.resetClickHandler($('.trungcap_content'), function (e) {
        e.stopPropagation();
        if (!$(this).hasClass("active")) {
            $(this).toggleClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Nội dung bạn muốn học','Trung cấp']);
        }
        $('.socap_content').removeClass("active");
        $('.caocap_content').removeClass("active");
    });
    utils.resetClickHandler($('.caocap_content'), function (e) {
        e.stopPropagation();
        if (!$(this).hasClass("active")) {
            $(this).toggleClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Nội dung bạn muốn học','Cao cấp']);
        }
        $('.socap_content').removeClass("active");
        $('.trungcap_content').removeClass("active");
    });
    utils.resetClickHandler($('.word_display'), function (e) {
        e.stopPropagation();
        if ($(this).hasClass('active')) {
            $(this).removeClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off word']);
            enable.word = 0;
        } else {
            $(this).addClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on word']);
            enable.word = 1;
        }
        updateEnable()
    });
    utils.resetClickHandler($('.kanji_display'), function (e) {
        e.stopPropagation();
        if ($(this).hasClass('active')) {
            $(this).removeClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Kanji']);
            enable.kanji = 0;
        } else {
            $(this).addClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Kanji']);
            enable.kanji = 1;
        }
        updateEnable();
    });
    utils.resetClickHandler($('.hiragana_display'), function (e) {
        e.stopPropagation();
        if ($(this).hasClass('active')) {
            $(this).removeClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Hiragana']);
            enable.hiragana = 0;
        } else {
            $(this).addClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Hiragana']);
            enable.hiragana = 1;
        }
        updateEnable();
    });
    utils.resetClickHandler($('.katakana_display'), function (e) {
        e.stopPropagation();
        if ($(this).hasClass('active')) {
            $(this).removeClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Katakana']);
            enable.katakana = 0;
        } else {
            $(this).addClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Katakana']);
            enable.katakana = 1;
        }
        updateEnable();
    });
    utils.resetClickHandler($('.phrase_display'), function (e) {
        e.stopPropagation();
        if ($(this).hasClass('active')) {
            $(this).removeClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn off Phrase']);
            enable.phrase = 0;
        } else {
            $(this).addClass("active");
            _gaq.push(['_trackEvent', config_app + ' Click', 'Những kiến thức bạn muốn học','Turn on Phrase']);
            enable.phrase = 1;
        }
        updateEnable();
    });
    function hideMenu() {
        $('#topsites_menu').fadeOut(200);
        $('#share_menu').fadeOut(200);
        $('#support_menu').fadeOut(200);

    }
    function interval () {
        setInterval(function() {
            var weather_widget = $('.widght');
            if (weather_widget.hasClass('block')) {
                $('.widght .time').fadeOut(100, function(){
                    $('.widght .weather').fadeIn().css('display', 'inline-block');
                });
                weather_widget.toggleClass('block');
            } else {
                $('.widght .weather').fadeOut(100, function(){
                    $('.widght .time').fadeIn().css('display', 'inline-block');
                });
                weather_widget.toggleClass('block');
            }

        },15000);
    }
    $scope.tracking = function (link) {
        if (link) {
            _gaq.push(['_trackEvent', 'Akira Global Extension', 'Link Quảng cáo', link]);
        } else {
            _gaq.push(['_trackEvent', 'Akira Global Extension', 'Link Logo', "Logo"]);
        }
    };

    $scope.update = function () {
        chrome.tabs.create({url: "chrome://extensions/"});
    };

    if (localStorage.address != null && localStorage.address != undefined) {
        var address = JSON.parse(localStorage.address);
        $scope.address = address.address;
        $service.getWeather(address,function (response) {
            if (response.status == 200) {
                $scope.weather = response.data.query;
            }
        });
    } else {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position){
                $service.getCityFromLatlong(position.coords.latitude, position.coords.longitude, function (response) {
                    if (response.results[0]) {
                        if (response.results[0].address_components.length > 0) {
                            var address_components = response.results[0].address_components;
                            var length = address_components.length;
                            var address = ( address_components[length - 2] ? address_components[length - 2].long_name : 'unknow administrative_area_level_1' );
                            var city = ( address_components[length - 1] ? address_components[length - 1].long_name : 'unknow administrative_area_level_1' );
                            localStorage.address = '{"address" : "'+address+'", "city" : "'+city+'"}';
                            var address_1 = JSON.parse(localStorage.address);
                            $scope.address = address_1.address;
                            $service.getWeather(address_1,function (res) {
                                if (res.status == 200) {
                                    $scope.weather = res.data.query;
                                }
                            });
                        } else {
                            console.log(response.results[0].formatted_address);
                        }
                    } else {
                        callback("No address or User not allow access location")
                    }
                })
            })
        }

    }
}